package pbcviewer;

import javax.microedition.lcdui.*;

public class AddComicForm extends Form {
	private final TextField comicName = new TextField(null, "", 30, TextField.ANY);
	private final TextField comicURL = new TextField(null, "http://", 255, TextField.ANY);
	private final ChoiceGroup contentRating = new ChoiceGroup(null, ChoiceGroup.POPUP);
	private StringItem si1 = null;
	private StringItem si2 = null;
	private StringItem si3 = null;
	
	protected PBCViewer mainProgram;
	
	public AddComicForm(PBCViewer p, String s)
	{
		super(s);
		
		mainProgram = p;
		
		StringItem si1 = new StringItem("", "Comic Name");
		si1.setLayout(Item.LAYOUT_CENTER);
		append(si1);
		
		append(comicName);
		
		si2 = new StringItem("", "Comic URL");
		si2.setLayout(Item.LAYOUT_CENTER);
		append(si2);
		
		append(comicURL);
		
		si3 = new StringItem("", "Content Rating");
		si3.setLayout(Item.LAYOUT_CENTER);
		append(si3);
		
		// add content rating options to popup
		MMCanvas.fillContentOptions(contentRating);
		
		append(contentRating);
		
		mainProgram.addCommands(this);
	}
	
	public String getComicName() { return comicName.getString(); }
	public String getComicURL()
	{
		// properly format the string
		String http = "";
		String endSlash = "";
		if (!comicURL.getString().startsWith("http://"))
			http = "http://";
		if (!comicURL.getString().endsWith("/"))
			endSlash = "/";
		
		return http + comicURL.getString() + endSlash;
	}
	public int getContentRating() { return contentRating.getSelectedIndex(); }
}