package pbcviewer;

import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

// simple yes/no confirm dialog
public class AlertDialog extends Object {
	String text = null;
	Canvas canvas = null;
	PBCViewer mainProgram = null;
	
	Image pic;
	public AlertDialog(String t, Canvas c, PBCViewer mp)
	{
		super();
		
		text = t;
		canvas = c;
		mainProgram = mp;
		
		Image i;
		
		try
		{
			i = Image.createImage("/alert.png");
			if (i.getHeight() > 24 || i.getWidth() > 24)
				i = null; // too big
		}
		catch (Exception ex) { i = null; }
		
		pic = i;
	}
	
	public void drawDialog(Graphics g)
	{
		g.setColor(240,240,240);
		g.fillRect((canvas.getWidth() / 2) - 80, (canvas.getHeight() / 2) - 35, 160, 70);
		g.setColor(0,0,0);
		g.drawRect((canvas.getWidth() / 2) - 81, (canvas.getHeight() / 2) - 36, 161, 71);
		if (pic != null)
			g.drawImage(pic, canvas.getWidth() / 2, (canvas.getHeight() / 2) - 35 + 1, Graphics.TOP | Graphics.HCENTER);
		Font f = Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_MEDIUM);
		
		// support one linebreak
		if (text.indexOf("\n") == -1)
			Utilities.drawString(g, text, (canvas.getWidth() / 2), canvas.getHeight() / 2, Graphics.TOP | Graphics.HCENTER, mainProgram, Font.SIZE_SMALL);
		else
		{
			String text1 = text.substring(0, text.indexOf("\n"));
			String text2 = text.substring(text.indexOf("\n") + 1);
			Utilities.drawString(g, text1, (canvas.getWidth() / 2), canvas.getHeight() / 2, Graphics.TOP | Graphics.HCENTER, mainProgram, Font.SIZE_SMALL);
			Utilities.drawString(g, text2, (canvas.getWidth() / 2), canvas.getHeight() / 2 + 10, Graphics.TOP | Graphics.HCENTER, mainProgram, Font.SIZE_SMALL);
		}
	}
	
	public String getText() { return text; }
}