package pbcviewer;

import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

// simple yes/no confirm dialog
public class ConfirmDialog extends Object {
	String text = null;
	boolean yesSelected = false;
	
	Canvas canvas = null;
	
	Image pic;
	public ConfirmDialog(String t, Canvas c)
	{
		super();
		
		text = t;
		canvas = c;
		
		Image i;
		
		try
		{
			i = Image.createImage("/alert.png");
			if (i.getHeight() > 24 || i.getWidth() > 24)
				i = null; // too big
		}
		catch (Exception ex) { i = null; }
		
		pic = i;
	}
	
	public void drawDialog(Graphics g)
	{
		g.setColor(240,240,240);
		g.fillRect((canvas.getWidth() / 2) - 80, (canvas.getHeight() / 2) - 35, 160, 70);
		g.setColor(0,0,0);
		g.drawRect((canvas.getWidth() / 2) - 81, (canvas.getHeight() / 2) - 36, 161, 71);
		if (pic != null)
			g.drawImage(pic, canvas.getWidth() / 2, (canvas.getHeight() / 2) - 35 + 1, Graphics.TOP | Graphics.HCENTER);
		Font f = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_MEDIUM);
		g.drawString(text, (canvas.getWidth() / 2), canvas.getHeight() / 2, Graphics.TOP | Graphics.HCENTER);
		
		// draw hilight for yes/no
		g.setColor(192, 192, 255);
		if (yesSelected) 
			g.fillRect((canvas.getWidth() / 2) - 40, (canvas.getHeight() / 2) + 14, 30, 13);
		else
			g.fillRect((canvas.getWidth() / 2) + 10, (canvas.getHeight() / 2) + 14, 30, 13);
		
		// draw yes/no
		g.setColor(0,0,0);
		g.drawString("Yes", (canvas.getWidth() / 2) - 25, (canvas.getHeight() / 2) + 15, Graphics.TOP | Graphics.HCENTER);
		g.drawString("No", (canvas.getWidth() / 2) + 25, (canvas.getHeight() / 2) + 15, Graphics.TOP | Graphics.HCENTER);
	}
	
	public void setYes(boolean y)
	{
		yesSelected = y;
	}
	
	public boolean getYes()
	{
		return yesSelected;
	}
	
	public String getText() { return text; }
}