// *****************************************
// (c) 2007 Pamela Bowman
// As if anyone'd steal this.
//
// Canvas for a form that holds a scrollable list.
// *****************************************

package pbcviewer;

import javax.microedition.lcdui.*;
import javax.microedition.rms.RecordStore;

import java.util.Timer;
import java.util.TimerTask;
import java.util.Vector;

public class MMCanvas extends Canvas {
	private class PBElement {
		private String displayName = null;
		private String primaryDir = null;
		private int contentRating = 0;
		private int recordID;
		
		public PBElement(String dName, String pDir, int cr, int rID)
		{
			displayName = dName; // typically the comic's name
			primaryDir = pDir; // url of directory of php files
			contentRating = cr;
			recordID = rID;
		}
		
		public String getDisplayName() { return displayName; }
		public String getURL() { return primaryDir; }
		public int getContentRating() { return contentRating; }
		public int getRecordID() { return recordID; }
	} 
	
	// border width/element height contents for menu part
	public static final int BORDER_WIDTH = 10;
	public static final int ELEMENT_HEIGHT = 15;
	
	// bottom and top border constants
	public static final int BOTTOM_BORDER = 10;
	public static final int TOP_BORDER = 15;
	
	// constants for menu labels
	public static final String COMIC_ADD = "Add Comic";
	public static final String COMIC_REMOVE = "Remove Comic";
	public static final String COMIC_MODIFY = "Modify Comic";
	public static final String OPTION_ABOUT = "About";
	public static final String OPTION_HELP = "Help";
	public static final String OPTION_EXIT = "Exit";
	public static final String OPTION_DEBUG = "Debug Messages";
	
	// DEBUG PURPOSES ONLY
	public static final String OPTION_NPE = "Cause NPE";
	
	// timer for holding key down
	protected Timer keyStillDownTimer = null;
	protected int keyStillDownCode = 0;
	
	// elements, elements selected
	protected Vector elements;
	protected int elementSelected = 0;
	protected int listScrollDown = 0;
	
	protected PBCViewer mainProgram;
	protected ComicCanvas cCanvas = null;
	
	// need to use the record store
	protected RecordStore records = null;
	
	// block key presses?
	protected boolean blockKeys = false;
	
	// menu variables
	protected Menu menu = null;
	protected boolean menuOpen = false;
	
	// remove comic variables
	protected GenericAlertDialog removeDialog = null;
	
	// ANY alert dialog!
	protected GenericAlertDialog alert = null;
	
	// add and modify comic forms
	AddComicForm acf = null;
	ModifyComicForm mcf = null;
	
	// main menu/instructions, need static image
	private Image mmImage;
	private Image mmInstImage;
	
	private class ArrowTimerTask extends TimerTask {
		public ArrowTimerTask()
		{
			super();
		}

		public void run() {
			// action key code. it can be multiple. THIS allows up-left etc.
			if (keyStillDownCode == Canvas.UP)
				doUpAction();
			if (keyStillDownCode == Canvas.DOWN)
				doDownAction();
		}
	}
	
	public MMCanvas(PBCViewer p)
	{
		super();
		
		
		// try loading images
		try {
			mmImage = Image.createImage("/mainmenu.png");
			mmInstImage = Image.createImage("/formm.png");
		} catch (Exception ex) {
			mmImage = null;
			mmInstImage = null;
		}
		
		mainProgram = p;
		elements = new Vector();
		
		// TEMP: Testing wordwrap string thing
		//Vector v = new Vector();
		//int it = Utilities.strNumLines("blah asdf hadlkjasd asdqwhr akjdcak ufehkwajfck bdafbakj bvaiubv jskbvbsakj bsakfbakjsjb kjsabkfcbaskjb kjsabkvbakj b biubuakb 788 87 tavgia76 vfc7t 9f76 f yf7 96f 6yf vuyoi f67 gf kvfuy yfi76 k", getWidth() - 2, v);
		//int it = Utilities.strNumLines("I'm a normal string, yes I am. Normal string I am I am! lalalal.\nThis is the dawning of the age of aquarius, the age of\naquarius, the age of aquariuuuuuuusssssssss!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Test quiz exam\na b c d\ne f g...ok\nthis is enuff.", getWidth() - 2, v);

		//int it = Utilities.strNumLines("aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbccccccccccccccccccccccccccccccccdddddddddddddddddddddddddddddddddddeeeeeeeeeeeeeeeeeeeeeeeeeeeeeffffffffffffffffffffffffffffffgggggggggggggggggggggggggggghhhhhhhhhhhhhhhhhhhhhhhhhhiiiiiiiiiiiiiiiiiiiiiiii", getWidth() - 2, v);
		//for (int i = 0; i < it; i++)
		//	System.out.println(it + (String) v.elementAt(i));
		
		// create menu
		menu = new Menu(this, mainProgram);
		menu.addOption(COMIC_ADD, false, false, false);
		menu.addOption(COMIC_MODIFY, false, false, false);
		menu.addOption(COMIC_REMOVE, false, false, false);
		if (PBCViewer.DEBUG_ON)
		{
			menu.addOption(OPTION_NPE, false, false, false);
			menu.addOption(OPTION_DEBUG, false, false, false);
		}
		menu.addOption(Menu.MENU_BREAK, true, false, false);
		menu.addOption(OPTION_HELP, false, false, false);
		menu.addOption(OPTION_ABOUT, false, false, false);
		menu.addOption(OPTION_EXIT, false, false, false);
		
		// open record store
		try {
			records = RecordStore.openRecordStore("PBCViewer", true);
			records.setMode(RecordStore.AUTHMODE_PRIVATE, true);
			
			// if no records, put in default "Tom"-like records. =p
			if (records.getNumRecords() < 1)
			{
				byte[] b = Utilities.charArrayToByteArray(new String("WAI Test Serverhttp://www.gaijinentertainment.com/webcomic/3").toCharArray());
				records.addRecord(b, 0, b.length);
				b = Utilities.charArrayToByteArray(new String("WAI Test ServerAhttp://www.gaijinentertainment.com/webcomic/4").toCharArray());
				records.addRecord(b, 0, b.length);
				b = Utilities.charArrayToByteArray(new String("WAI Test ServerGhttp://www.gaijinentertainment.com/webcomic/1").toCharArray());
				records.addRecord(b, 0, b.length);
				b = Utilities.charArrayToByteArray(new String("WAI Test ServerKhttp://www.gaijinentertainment.com/webcomic/2").toCharArray());
				records.addRecord(b, 0, b.length);
			}
		} catch (Exception ex) {
			System.out.println(ex);
			try { mainProgram.destroyApp(true); } catch (Exception ey) { }
			return;
		}
		
		try {
			addElements();
		} catch (Exception ex) {
			System.out.println(ex);
			try { mainProgram.destroyApp(true); } catch (Exception ey) { }
			return;
		}
		
		// for testing alert scorlling
		//alert = new GenericAlertDialog(this, mainProgram, "1\n2\n3\n4\n5\n6\n7\n8\n9\n10\n11\n12\n13\n14\n15\n16\n17\n18\n19\n20\n21\n22\n23\n24\n25\n26\n27\n28\n29\n30\n31\n32\n33\n34\n35\n", 100, false, false);
	}
	
	// returns the number of elements that can be on screen
	// it's not rounded for scrollbar accuracy
	public float elementsPerScreen()
	{
		return (getHeight() - (BORDER_WIDTH * 2) - BOTTOM_BORDER - TOP_BORDER) / ELEMENT_HEIGHT;  
	}
	
	// add the comics.
	private void addElements() throws Exception
	{
		int it = 0; // an iterator of sorts. bah.
		
		// get data from the record and pray it can be translated. lol
		for (int i = 1; it < records.getNumRecords(); i++)
		{
			byte[] b;
			
			// horrible i need to do this to get the current record. ugh
			try { b = records.getRecord(i); }
			catch (Exception ex) { continue; }
			
			// if it gets here, record found. increase "it"
			it++;
			
			//System.out.println("Valid record at: " + it);
			
			int j;
			
			StringBuffer comicName = new StringBuffer("");
			
			// go through "b" and get important data
			for (j = 0; j < b.length; j++)
			{
				if (b[j] == (byte)'')
					break;
				
				comicName.append((char) b[j]);
			}
			
			// now get comic url
			j++;
			StringBuffer comicURL = new StringBuffer("");
			
			for ( ; j < b.length; j++)
			{
				if (b[j] == (byte)'')
					break;
				
				comicURL.append((char) b[j]);
			}
			
			// now get content rating number thingy. should only be one char
			j++;
			StringBuffer contentRating = new StringBuffer("");
			
			for ( ; j < b.length; j++)
			{
				contentRating.append((char) b[j]);
				break;
			}
			
			if (contentRating.toString() == "")
				contentRating.append('0');
			
			int cr = 0;
			
			try { cr = Integer.parseInt(contentRating.toString());
			} catch (Exception ex) { }
			
			// lets create our element! "i" must be the recordID, necessary to delete
			elements.addElement(new PBElement(comicName.toString(), comicURL.toString(), cr, i));
		}
	}

	protected void paint(Graphics g) {
		// white background for now
		g.setColor(255, 255, 255);
		g.fillRect(0, 0, getWidth(), getHeight());
		
		g.setColor(0, 0, 0);
		Font f = Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_MEDIUM);
		g.setFont(f);
		
		// draw options. do NOT draw offscreen options!!
		for (int i = listScrollDown; i < listScrollDown + elementsPerScreen() + 1; i++)
		{
			if (i >= elements.size()) break; // don't let i go over # of elements
			
			// draw hilight if applicable
			if (i == elementSelected)
			{
				for (int j = 0; j < 6; j++)
				{
					g.setColor(16 * (j + 3), 16 * (j + 3), 255);
					g.fillRect(BORDER_WIDTH, (BORDER_WIDTH + TOP_BORDER + j) + (ELEMENT_HEIGHT * i) - (listScrollDown * ELEMENT_HEIGHT), getWidth() - (BORDER_WIDTH * 2), 1);
				}

				g.setColor(128, 128, 255);
				g.fillRect(BORDER_WIDTH, (BORDER_WIDTH + TOP_BORDER + 6) + (ELEMENT_HEIGHT * i) - (listScrollDown * ELEMENT_HEIGHT), getWidth() - (BORDER_WIDTH * 2), 3);

				for (int j = 5; j >= 0; j--)
				{
					g.setColor(16 * (j + 3), 16 * (j + 3), 255);
					g.fillRect(BORDER_WIDTH, ((BORDER_WIDTH + TOP_BORDER + ELEMENT_HEIGHT - 1) - j) + (ELEMENT_HEIGHT * i) - (listScrollDown * ELEMENT_HEIGHT), getWidth() - (BORDER_WIDTH * 2), 1);
				}
				
				g.setColor(0,0,0);
			}
			
			PBElement e = (PBElement) elements.elementAt(i);
			
			// elements can be width-10x20, start string at 3 into the element's height
			Utilities.drawString(g, e.getDisplayName(), (BORDER_WIDTH + 5), (BORDER_WIDTH + TOP_BORDER + 3) + (ELEMENT_HEIGHT * i) - (listScrollDown * ELEMENT_HEIGHT), Graphics.TOP | Graphics.LEFT, mainProgram, Font.SIZE_SMALL);
			//g.drawString(e.getDisplayName(), (BORDER_WIDTH + 5), (BORDER_WIDTH + TOP_BORDER + 3) + (ELEMENT_HEIGHT * i) - (listScrollDown * ELEMENT_HEIGHT), Graphics.TOP | Graphics.LEFT);
		}
		
		// borders just something basic right now
		for (int i = 0; i < 10; i++)
		{
			g.setColor(8 * i, 8 * i, 8 * i);
			g.drawRect(i, TOP_BORDER + i, getWidth() - (i*2) - 1, getHeight() - TOP_BORDER - BOTTOM_BORDER - (i*2) - 1);
		}
		
		// draw bottom/top border space
		g.setColor(0,0,0);
		g.fillRect(0, 0, getWidth(), TOP_BORDER);
		g.fillRect(0, getHeight() - BOTTOM_BORDER, getWidth(), BOTTOM_BORDER);
		
		// draw main menu text
		g.setColor(255,255,255);
		Font fnt = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_BOLD, Font.SIZE_LARGE);
		g.setFont(fnt);
		if (mmImage != null)
			g.drawImage(mmImage, getWidth() / 2, 2, Graphics.HCENTER | Graphics.TOP);
		
		// draw the bottom menu options
		Font smallFnt = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL);
		g.setFont(smallFnt);

		// damn softkey non-standardization, these will probably never return
		//g.drawString("Exit", 3, getHeight(), Graphics.LEFT | Graphics.BOTTOM);
		//g.drawString("Go", getWidth() - 3, getHeight(), Graphics.RIGHT | Graphics.BOTTOM);
		if (mmInstImage != null)
			g.drawImage(mmInstImage, getWidth() / 2, getHeight() - mmInstImage.getHeight(), Graphics.HCENTER | Graphics.TOP);
		
		// draw the scrollbar!
		Scrollbar.drawScrollbar(g, getWidth(), getHeight(), elements.size(),
				elementsPerScreen(), listScrollDown, BORDER_WIDTH + TOP_BORDER, BORDER_WIDTH,
				BORDER_WIDTH, BORDER_WIDTH + BOTTOM_BORDER, true, false);
		
		// now draw the menu if applicable
		if (menuOpen)
			menu.paint(g, BOTTOM_BORDER);
		
		// draw remove dialog if applicable
		if (removeDialog != null)
			removeDialog.drawDialog(g);
		
		// draw alert if applicable
		if (alert != null)
			alert.drawDialog(g);
	}
	
	public void addElement(String hashCode)
	{
		elements.addElement(hashCode);
	}
	
	protected void doUpAction()
	{
		if (elementSelected > 0)
		{
			elementSelected--;
			
			// figure out HERE if the program needs to scroll up
			if (elementSelected < listScrollDown)
			{
				listScrollDown = elementSelected; // that was easy.

				// repaint all
				repaint();
			}
			else
			{
				// repaint affected area only
				repaint(BORDER_WIDTH, ((elementSelected - listScrollDown) * ELEMENT_HEIGHT) + BORDER_WIDTH + TOP_BORDER, getWidth() - (BORDER_WIDTH * 2), ELEMENT_HEIGHT * 2);					
			}
		}
	}
	
	protected void doDownAction()
	{
		if (elementSelected < elements.size() - 1)
		{
			elementSelected++;
			
			// figure out HERE if the program needs to scroll down
			int bottomLimit = getHeight() - BORDER_WIDTH - BOTTOM_BORDER;
			int bottomOfBottom = ((elementSelected - listScrollDown) * ELEMENT_HEIGHT) + BORDER_WIDTH + ELEMENT_HEIGHT + TOP_BORDER;
			if (bottomOfBottom > bottomLimit)
			{
				listScrollDown++; // that was less easy.
				
				// repaint entire
				repaint();
			}
			else
			{
				// repaint affected area only
				repaint(BORDER_WIDTH, bottomOfBottom - (ELEMENT_HEIGHT * 2), getWidth() - (BORDER_WIDTH * 2), ELEMENT_HEIGHT * 2);
			}
		}
	}
	
	protected void keyPressedAlertConfirm(int keyCode, int oldKeyCode)
	{
		// simply remove the alert.
		if (keyCode == Canvas.FIRE)
		{
			alert = null;
			repaint();
		}
		else if (keyCode == Canvas.UP)
		{
			if (alert.upPressed()) repaint();
		}
		else if (keyCode == Canvas.DOWN)
		{
			if (alert.downPressed()) repaint();
		}
	}
	
	protected void keyPressedRemoveConfirm(int keyCode, int oldKeyCode)
	{
		if (keyCode == Canvas.LEFT && !removeDialog.getYes())
		{
			removeDialog.setYes(true);
			repaint();
		}
		else if (keyCode == Canvas.RIGHT && removeDialog.getYes())
		{
			removeDialog.setYes(false);
			repaint();
		}
		else if (keyCode == Canvas.FIRE)
		{
			if (!removeDialog.getYes())
			{
				// destroy dialog, repaint
				removeDialog = null;
				repaint();
			}
			else
			{
				PBElement e = (PBElement) elements.elementAt(elementSelected);
				String oldEleString = e.getDisplayName();
				
				// remove the element from the record store
				try {
					records.deleteRecord(e.getRecordID()); // cause store starts at 1
					reloadElements();
					alert = new GenericAlertDialog(this, mainProgram,
							oldEleString + " removed successfully!", (getWidth() / 4) * 3, true, false);
				} catch (Exception ex) {
					alert = new GenericAlertDialog(this, mainProgram,
							"Error: Could not delete record from store!", (getWidth() / 4) * 3, true, false);
				}
				removeDialog = null;
				repaint();
			}
		}
	}
	
	protected void reloadElements() throws Exception
	{
		elements.removeAllElements();
		records.closeRecordStore();
		records = RecordStore.openRecordStore("PBCViewer", true);
		addElements();
		elementSelected = 0;
		listScrollDown = 0;
	}
	
	protected void keyPressedWithMenuOpen(int keyCode, int oldKeyCode)
	{
		// scroll up and down menu options, simple self correction
		if (keyCode == Canvas.UP)
		{
			menu.upOption();
			return;
		}
		else if (keyCode == Canvas.DOWN)
		{
			menu.downOption();
			return;
		}
		else if (oldKeyCode == Canvas.KEY_STAR || oldKeyCode == Canvas.KEY_POUND)
		{
			menuOpen = false;
			repaint();
		}
		else if (keyCode == Canvas.FIRE)
		{
			// 0 = add, 1 = modify, 2 = remove
			if (menu.getText().equals(COMIC_ADD))
			{
				acf = new AddComicForm(mainProgram, "Add Comic");
				if (acf != null)
					mainProgram.getDisplay().setCurrent(acf);
				
				menuOpen = false;
			}
			else if (menu.getText().equals(COMIC_MODIFY))
			{
				PBElement e = (PBElement) elements.elementAt(elementSelected);
				mcf = new ModifyComicForm(mainProgram, e.getDisplayName(), e.getRecordID(), e.getDisplayName(), e.getURL(), e.getContentRating());
				
				if (mcf != null)
					mainProgram.getDisplay().setCurrent(mcf);
				
				menuOpen = false;
			}
			else if (menu.getText().equals(COMIC_REMOVE))
			{
				// anything selected?
				if (elements.size() == 0)
				{
					alert = new GenericAlertDialog(this, mainProgram,
							"Nothing to remove!", (getWidth() / 4) * 3, true, false);
					repaint();
					return;
				}
				
				PBElement e = (PBElement) elements.elementAt(elementSelected);
				removeDialog = new GenericAlertDialog(this, mainProgram, "Remove " + e.getDisplayName() + "?", getWidth() / 2, true, true);
				menuOpen = false; // close menu now
				repaint();
			}
			else if (menu.getText().equals(OPTION_EXIT))
			{
				mainProgram.killApp();
			}
			else if (menu.getText().equals(OPTION_ABOUT))
			{
				// about dialog as a generic alert :)
				alert = mainProgram.createAboutDialog(this);
				menuOpen = false;
				repaint();
			}
			else if (menu.getText().equals(OPTION_DEBUG))
			{
				alert = mainProgram.createDebugDialog(this);
				menuOpen = false;
				repaint();
			}
			else if (menu.getText().equals(OPTION_HELP))
			{
				// help dialog as a generic alert :)
				alert = new GenericAlertDialog(this, mainProgram, "Press Up/Down to scroll"
						+ " through the lists. Press * to open menu. If you want to add a comic that"
						+ " supports the PBComic system, choose Add Comic. Modify Comic lets you"
						+ " change a comic's URL, name, or content rating. Remove comic does just"
						+ " that, but if you have no comics when you start the app again, the"
						+ " default comics will reappear.", (getWidth() / 8) * 7, false, false);
				menuOpen = false;
				repaint();
			}
			else if (menu.getText().equals(OPTION_NPE))
			{
				String junktest = null;
				char[] a = junktest.toCharArray();
			}
		}
	}
	
	protected void keyPressedNormalMode(int keyCode, int oldKeyCode)
	{
		// change and repaint
		if (keyCode == Canvas.UP)
		{
			doUpAction();
		}
		else if (keyCode == Canvas.DOWN)
		{
			doDownAction();
		}
		
		if (keyCode == Canvas.UP || keyCode == Canvas.DOWN)
		{
			killTimer();
			keyStillDownCode = keyCode;
			keyStillDownTimer = new Timer();
			keyStillDownTimer.schedule(new ArrowTimerTask(), 750, 75);
		}
		
		// fire pressed, go to comic!
		if (keyCode == Canvas.FIRE)
		{
			if (elements.size() == 0)
			{
				alert = new GenericAlertDialog(this, mainProgram,
						"No comic to select!", (getWidth() / 4) * 3, true, false);
				repaint();
				return;
			}
			killTimer();
			//setKeyBlock(true);
			PBElement p = (PBElement) elements.elementAt(elementSelected);
			if (cCanvas != null)
			{
				if (cCanvas.getComicURL().equals(p.getURL()))
				{
					// do nothing, want this to reload
				}
				else
				{
					cCanvas = null; // collect by GC
					cCanvas = new ComicCanvas(mainProgram, p.getDisplayName(), p.getURL());
				}
			}
			else
				cCanvas = new ComicCanvas(mainProgram, p.getDisplayName(), p.getURL());
			
			mainProgram.getDisplay().setCurrent(cCanvas);
		}
		
		// * or # pressed, open menu
		if (oldKeyCode == Canvas.KEY_STAR || oldKeyCode == Canvas.KEY_POUND)
		{
			killTimer(); // jic
			menuOpen = true;
			menu.resetMenu();
			repaint();
		}
	}
	
	protected void keyPressed(int keyCode)
	{	
		if (blockKeys) return; // ignore key presses jic
		
		// need to preserve and pass the old key code, for keys like * and #
		int oldKeyCode = keyCode;
		
		// must always change this into a game action code
		keyCode = getGameAction(keyCode);
		
		// lets separate these into multiple functions
		if (alert != null)
			keyPressedAlertConfirm(keyCode, oldKeyCode);
		else if (removeDialog != null)
			keyPressedRemoveConfirm(keyCode, oldKeyCode);
		else if (menuOpen)
			keyPressedWithMenuOpen(keyCode, oldKeyCode);
		else
			keyPressedNormalMode(keyCode, oldKeyCode);
	}
	
	protected void keyReleased(int keyCode)
	{
		// must always change this into a game action code
		keyCode = getGameAction(keyCode);
		
		if (keyStillDownCode == keyCode)
			killTimer();
	}
	
	protected void killTimer()
	{
		if (keyStillDownTimer != null)
		{
			keyStillDownTimer.cancel();
			keyStillDownTimer = null;
		}
	}
	
	// why did I include this?
	//public void setKeyBlock(boolean kb) { blockKeys = kb; }
	
	public ComicCanvas getComicCanvas() { return cCanvas; }
	public void setComicCanvas(ComicCanvas c) { cCanvas = c; }
	
	public void closeRecords() throws Exception
	{
		if (records != null)
			records.closeRecordStore();
	}
	
	public void addNewComicRecord(String cn, String cu, int cr)
	{ // comic name, comic url, content rating, recordID
		try {
			byte[] b = Utilities.charArrayToByteArray(new String(cn + "" + cu + "" + Integer.toString(cr)).toCharArray());
			String s = new String(Utilities.byteArrayToCharArray(b));
			records.addRecord(b, 0, b.length);
			reloadElements();
			alert = new GenericAlertDialog(this, mainProgram,
					cn + ": Comic added successfully!", (getWidth() / 4) * 3, true, false);
		} catch (Exception ex) {
			alert = new GenericAlertDialog(this, mainProgram,
					"Error: Can't add new comic record!", (getWidth() / 4) * 3, true, false);
			System.out.println(ex);
		}
		
		
		repaint();
		acf = null; // clean this up
	}
	
	public void modifyComicRecord(String cn, String cu, int cr, int rID)
	{ // comic name, url, content rating, record ID
		try {
			byte[] b = Utilities.charArrayToByteArray(new String(cn + "" + cu + "" + Integer.toString(cr)).toCharArray());
			records.setRecord(rID, b, 0, b.length);
			reloadElements();
			alert = new GenericAlertDialog(this, mainProgram,
					cn + ": Comic modified successfully!", (getWidth() / 4) * 3, true, false);
		} catch (Exception ex) {
			alert = new GenericAlertDialog(this, mainProgram,
					"Error: Can't modify comic!", (getWidth() / 4) * 3, true, false);
			System.out.println("Bunk record ID: " + rID);
			System.out.println(ex);
		}
		
		repaint();
		mcf = null;
	}
	
	public Form getAddForm() { return acf; }
	public Form getModifyForm() { return mcf; }
	
	public static void fillContentOptions(ChoiceGroup c)
	{
		c.append("All audiences", null);
		c.append("Kids", null);
		c.append("Ages 14 and up", null);
		c.append("Adults only", null);
		c.setLayout(Item.LAYOUT_CENTER);
	}
}