package pbcviewer;

import javax.microedition.lcdui.*;

public class ModifyComicForm extends Form {
	private final TextField comicName = new TextField(null, "", 30, TextField.ANY);
	private final TextField comicURL = new TextField(null, "http://", 255, TextField.ANY);
	private final ChoiceGroup contentRating = new ChoiceGroup(null, ChoiceGroup.POPUP);
	private StringItem si1 = null;
	private StringItem si2 = null;
	private StringItem si3 = null;
	
	private int recordID;
	
	protected PBCViewer mainProgram;
	
	public ModifyComicForm(PBCViewer p, String s, int oldComicRecordID, String cn, String cu, int cr)
	{
		super(s);
		
		mainProgram = p;
		
		// set current values
		comicName.setString(cn);
		comicURL.setString(cu);
		recordID = oldComicRecordID;
		
		StringItem si1 = new StringItem("", "Comic Name");
		si1.setLayout(Item.LAYOUT_CENTER);
		append(si1);
		
		append(comicName);
		
		si2 = new StringItem("", "Comic URL");
		si2.setLayout(Item.LAYOUT_CENTER);
		append(si2);
		
		append(comicURL);
		
		si3 = new StringItem("", "Content Rating");
		si3.setLayout(Item.LAYOUT_CENTER);
		append(si3);
		
		// add content rating options to popup then set current value
		MMCanvas.fillContentOptions(contentRating);
		System.out.println(cr + " option");
		contentRating.setSelectedIndex(cr, true);
		
		append(contentRating);
		
		mainProgram.addCommands(this);
	}
	
	public String getComicName() { return comicName.getString(); }
	public String getComicURL()
	{
		// properly format the string
		String http = "";
		String endSlash = "";
		if (!comicURL.getString().startsWith("http://"))
			http = "http://";
		if (!comicURL.getString().endsWith("/"))
			endSlash = "/";
		
		return http + comicURL.getString() + endSlash;
	}
	public int getContentRating() { return contentRating.getSelectedIndex(); }
	public int getRecordID() { return recordID; }
}