// *****************************************
// (c) 2007 Pamela Bowman
// I could see someone actually stealing this.
// So don't.
//
// Draw horizontal or vertical windows-like scrollbars.
// *****************************************

package pbcviewer;

import javax.microedition.lcdui.Graphics;

public class Scrollbar
{
	private static final int ARROW_UP = 1;
	private static final int ARROW_DOWN = 2;
	private static final int ARROW_LEFT = 3;
	private static final int ARROW_RIGHT = 4;
	
	public static final int WIDTH = 9;
	
	private static void drawSBArrow(Graphics g, int scrollbarx, int heightStart, int dir)
	{
		g.setColor(88, 88, 88);
		g.drawLine(scrollbarx, heightStart, scrollbarx, heightStart + WIDTH - 2);
		g.drawLine(scrollbarx, heightStart, scrollbarx + WIDTH - 2, heightStart);
		g.fillRect(scrollbarx + 2, heightStart + 2, WIDTH - 4, WIDTH - 4);
		// lighter color on top-left rim
		g.setColor(128, 128, 128);
		g.drawLine(scrollbarx + 1, heightStart + 1, scrollbarx + 1, heightStart + WIDTH - 3);
		g.drawLine(scrollbarx + 1, heightStart + 1, scrollbarx + WIDTH - 3, heightStart + 1);
		// darker color on bottom-right rim
		g.setColor(48, 48, 48);
		g.drawLine(scrollbarx + 1, heightStart + WIDTH - 2, scrollbarx + WIDTH - 2, heightStart + WIDTH - 2);
		g.drawLine(scrollbarx + WIDTH - 2, heightStart + 1, scrollbarx + WIDTH - 2, heightStart + WIDTH - 2);
		// darkest color which also ends up being color for arrow
		g.setColor(8, 8, 8);
		g.drawLine(scrollbarx, heightStart + WIDTH - 1, scrollbarx + WIDTH - 1, heightStart + WIDTH - 1);
		g.drawLine(scrollbarx + WIDTH - 1, heightStart + 0, scrollbarx + WIDTH - 1, heightStart + WIDTH - 1);
		
		// hw = halfWidth
		int hw = WIDTH / 2;

		// draw arrow
		if (dir == ARROW_UP)
		{
			int hMod = 2; // height mod
			if (WIDTH < 10)
				hMod = 1;
			
			if (WIDTH >= 8)
			{
				g.drawLine(scrollbarx + hw, heightStart + hw - hMod, scrollbarx + hw, heightStart + hw - hMod);
				g.drawLine(scrollbarx + hw - 1, heightStart + hw - hMod + 1, scrollbarx + hw + 1, heightStart + hw - hMod + 1);
			}
			if (WIDTH >= 10)
				g.drawLine(scrollbarx + hw - 2, heightStart + hw - hMod + 2, scrollbarx + hw + 2, heightStart + hw - hMod + 2);
			if (WIDTH >= 12)
				g.drawLine(scrollbarx + hw - 3, heightStart + hw - hMod + 3, scrollbarx + hw + 3, heightStart + hw - hMod + 3);
		}
		else if (dir == ARROW_DOWN)
		{
			int hMod = 1; // height mod
			if (WIDTH < 10)
				hMod = 2;
			
			if (WIDTH >= 12)
				g.drawLine(scrollbarx + hw - 3, heightStart + hw - hMod, scrollbarx + hw + 3, heightStart + hw - hMod);
			if (WIDTH >= 10)
				g.drawLine(scrollbarx + hw - 2, heightStart + hw - hMod + 1, scrollbarx + hw + 2, heightStart + hw - hMod + 1);
			
			if (WIDTH >= 8)
			{
				g.drawLine(scrollbarx + hw - 1, heightStart + hw - hMod + 2, scrollbarx + hw + 1, heightStart + hw - hMod + 2);
				g.drawLine(scrollbarx + hw, heightStart + hw - hMod + 3, scrollbarx + hw, heightStart + hw - hMod + 3);
			}
		}
		else if (dir == ARROW_LEFT)
		{
			int wMod = 2; // width mod
			if (WIDTH < 10)
				wMod = 1;
			
			if (WIDTH >= 8)
			{
				g.drawLine(scrollbarx + hw - wMod, heightStart + hw, scrollbarx + hw - wMod, heightStart + hw);
				g.drawLine(scrollbarx + hw - wMod + 1, heightStart + hw - 1, scrollbarx + hw - wMod + 1, heightStart + hw + 1);
			}
			if (WIDTH >= 10)
				g.drawLine(scrollbarx + hw - wMod + 2, heightStart + hw - 2, scrollbarx + hw - wMod + 2, heightStart + hw + 2);
			if (WIDTH >= 12)
				g.drawLine(scrollbarx + hw - wMod + 3, heightStart + hw - 3, scrollbarx + hw - wMod + 3, heightStart + hw + 3);
		}
		else if (dir == ARROW_RIGHT)
		{
			int wMod = 1; // width mod
			if (WIDTH < 10)
				wMod = 2;
			
			if (WIDTH >= 12)
				g.drawLine(scrollbarx + hw - wMod, heightStart + hw - 3, scrollbarx + hw - wMod, heightStart + hw + 3);
			if (WIDTH >= 10)
				g.drawLine(scrollbarx + hw - wMod + 1, heightStart + hw - 2, scrollbarx + hw - wMod + 1, heightStart + hw + 2);
			if (WIDTH >= 8)
			{
				g.drawLine(scrollbarx + hw - wMod + 2, heightStart + hw - 1, scrollbarx + hw - wMod + 2, heightStart + hw + 1);
				g.drawLine(scrollbarx + hw - wMod + 3, heightStart + hw, scrollbarx + hw - wMod + 3, heightStart + hw);
			}
		}
	}
	
	private static void drawSBBar(Graphics g, int scrollbarx, int scrollbary, int scrollbarStart, int scrollbarHW, int scrollbarMax, boolean vertical)
	{
		if (vertical)
		{
			// we have all we need. draw the scrollbar's unoccupied space
			g.setColor(156, 156, 156);
			g.fillRect(scrollbarx, scrollbary, WIDTH, scrollbarStart);
			g.fillRect(scrollbarx, scrollbary + scrollbarStart + scrollbarHW, WIDTH, (scrollbarMax - scrollbarHW) - scrollbarStart + 1);
			
			int startY = scrollbary + scrollbarStart;
			// now the scrollbar itself
			g.setColor(88, 88, 88);
			g.drawLine(scrollbarx, startY, scrollbarx, startY + scrollbarHW);
			g.drawLine(scrollbarx, startY, scrollbarx + WIDTH - 1, startY);
			g.fillRect(scrollbarx + 2, startY + 2, WIDTH - 4, scrollbarHW - 2);
			// lighter color on top-left rim
			g.setColor(128, 128, 128);
			g.drawLine(scrollbarx + 1, startY + 1, scrollbarx + 1, startY + scrollbarHW - 1);
			g.drawLine(scrollbarx + 1, startY + 1, scrollbarx + WIDTH - 3, startY + 1);
			// darker color on bottom-right rim
			g.setColor(48, 48, 48);
			g.drawLine(scrollbarx + 1, startY + scrollbarHW - 1, scrollbarx + WIDTH - 2, startY + scrollbarHW - 1);
			g.drawLine(scrollbarx + WIDTH - 2, startY + 1, scrollbarx + WIDTH - 2, startY + scrollbarHW - 1);
			// darkest color which also ends up being color for arrow
			g.setColor(8, 8, 8);
			g.drawLine(scrollbarx, startY + scrollbarHW, scrollbarx + WIDTH - 1, startY + scrollbarHW);
			g.drawLine(scrollbarx + WIDTH - 1, startY, scrollbarx + WIDTH - 1, startY + scrollbarHW);
		}
		else
		{
			// we have all we need. draw the scrollbar's unoccupied space
			g.setColor(156, 156, 156);
			g.fillRect(scrollbarx, scrollbary, scrollbarStart, WIDTH);
			g.fillRect(scrollbarx + scrollbarStart + scrollbarHW, scrollbary, (scrollbarMax - scrollbarHW) - scrollbarStart + 1, WIDTH);
			
			int startX = scrollbarx + scrollbarStart;
			// now the scrollbar itself
			g.setColor(88, 88, 88);
			g.drawLine(startX, scrollbary, startX + scrollbarHW, scrollbary);
			g.drawLine(startX, scrollbary, startX, scrollbary + WIDTH - 1);
			g.fillRect(startX + 2, scrollbary + 2, scrollbarHW - 2, WIDTH - 4);
			// lighter color on top-left rim
			g.setColor(128, 128, 128);
			g.drawLine(startX + 1, scrollbary + 1, startX + 1, scrollbary + WIDTH - 3);
			g.drawLine(startX + 1, scrollbary + 1, startX + scrollbarHW - 2, scrollbary + 1);
			// darker color on bottom-right rim
			g.setColor(48, 48, 48);
			g.drawLine(startX + 1, scrollbary + WIDTH - 2, startX + scrollbarHW - 1, scrollbary + WIDTH - 2);
			g.drawLine(startX + scrollbarHW - 1, scrollbary + 1, startX + scrollbarHW - 1, scrollbary + WIDTH - 2);
			// darkest color which also ends up being color for arrow
			g.setColor(8, 8, 8);
			g.drawLine(startX, scrollbary + WIDTH - 1, startX + scrollbarHW, scrollbary + WIDTH - 1);
			g.drawLine(startX + scrollbarHW, scrollbary, startX + scrollbarHW, scrollbary + WIDTH - 1);			
		}
	}
	
	// draws the scrollbar, which is 13 pixels wide
	// ugh, here's an explanation of everything:
	// Graphics g: The Graphics object being drawn onto
	// canvasWidth: just pass getWidth()
	// canvasHeight: just pass getHeight()
	// numElements: elements in the list being scrolled. this is pretty flexible, and can be taken down to the pixel level
	// elementsVisible: # elements visible on screen
	// elementsScrolledDown: # elements that are "above" the visible elements on list
	// topBorder, leftBorder, rightBorder, bottomBorder - the four borders...determines
	//        where the drawing of the scrollbar begins relative to top/left/right/bottom
	//        screen limits
	// vertical: true = vertical scrollbar, false = horizontal. hori not implemented yet
	// twoScrollbars: in this case, if there's both horizontal AND vertical scrollbars
	//        draw a color = scrollbar main color 13x13 block so the two scrollbars
	//        can never overlap, and modify certain vars accordingly
	public static void drawScrollbar(Graphics g, int canvasWidth, int canvasHeight,
			int numElements, float elementsVisible, int elementsScrolledAway,
			int topBorder, int leftBorder, int rightBorder, int bottomBorder,
			boolean vertical, boolean twoScrollbars)
	{
		final int scrollbarx = (canvasWidth - leftBorder) - WIDTH;
		final int scrollbary = (canvasHeight - bottomBorder) - WIDTH;
		
		// don't draw if not needed. don't let size be zero
		if (numElements <= elementsVisible || numElements == 0)
			return;
		
		// change bottom border if vertical = true and twoScrollbars = true
		if (vertical && twoScrollbars)
			bottomBorder += WIDTH;
		else if (!vertical && twoScrollbars)
			rightBorder += WIDTH;
		
		// vertical first
		if (vertical)
		{
			// draw the scrollbar arrows
			// get limits
			int topLimit = topBorder + WIDTH; // less than or equal
			int bottomLimit = (canvasHeight - bottomBorder) - WIDTH; // greater than or equal
			int scrollbarMax = bottomLimit - topLimit - 1;
			float scrollbarSizeMod = elementsVisible / numElements; // must be <1
			
			// draw arrows
			drawSBArrow(g, scrollbarx, topBorder, ARROW_UP); // top arrow
			drawSBArrow(g, scrollbarx, bottomLimit, ARROW_DOWN); // bottom arrow
			
			// figure out scrollbar height
			float oselements = numElements - elementsVisible;
			int scrollbarHeight = (int) (scrollbarMax * scrollbarSizeMod);
			
			// extreme case: don't let scrollbarHeight be less than 5
			if (scrollbarHeight < 5) scrollbarHeight = 5;
			
			// need to get a whole number for offscreen elements for next calc
			int ioselements = (int) oselements;
			if (ioselements < oselements) ioselements += 1;
			
			// now where do we start the scrollbar?
			int scrollbarEmpty = scrollbarMax - scrollbarHeight; // empty SB space
			int scrollbarStart = (int)(scrollbarEmpty * ((float)elementsScrolledAway / oselements));
			
			drawSBBar(g, scrollbarx, topLimit, scrollbarStart, scrollbarHeight, scrollbarMax, vertical);
			
			// draw block thing ONLY for vertical scrollbar and twoScrollbars
			// I figure if someone draws 2 scrollbars, this only needs to be drawn in once
			// otherwise the programmer messed up and I don't care. :)
			if (twoScrollbars)
			{
				g.setColor(88, 88, 88);
				g.fillRect(scrollbarx, bottomLimit + WIDTH, WIDTH, WIDTH);
			}
		}
		else // horizontal
		{
			// draw the scrollbar arrows
			// get limits
			int leftLimit = leftBorder + WIDTH; // where bars can start being drawn
			int rightLimit = (canvasWidth - rightBorder) - WIDTH; // where bars end up right side
			int scrollbarMax = rightLimit - leftLimit - 1;
			float scrollbarSizeMod = elementsVisible / numElements; // must be <1
			
			// draw arrows
			drawSBArrow(g, leftBorder, scrollbary, ARROW_LEFT); // top arrow
			drawSBArrow(g, rightLimit, scrollbary, ARROW_RIGHT); // bottom arrow
			
			// figure out scrollbar width, also get # offscreen elements
			float oselements = numElements - elementsVisible;
			int scrollbarWidth = (int) (scrollbarMax * scrollbarSizeMod);
			
			// extreme case: don't let scrollbarWidth be less than 5
			if (scrollbarWidth < 5) scrollbarWidth = 5;
			
			// need to get a whole number for offscreen elements for next calc
			int ioselements = (int) oselements;
			if (ioselements < oselements) ioselements += 1;
			
			// now where do we start the scrollbar?
			int scrollbarEmpty = scrollbarMax - scrollbarWidth; // empty SB space
			int scrollbarStart = (int)(scrollbarEmpty * ((float)elementsScrolledAway / oselements));
			
			drawSBBar(g, leftLimit, scrollbary, scrollbarStart, scrollbarWidth, scrollbarMax, vertical);
		}
	}
}